//Copyright (c) 1997 Aidan Cully
//All rights reserved

#ifndef __DRAWSLATE_H
#define __DRAWSLATE_H

#include <QuickDraw.h>

//class TDrawSlate
//	uses:
//		Used to manage drawing areas.
//	theory:
//		A "drawing slate" is an area which one can draw to.  Drawing occurs through the use of
//		"shape" objects which draw themselves onto one of these.
//	Future changes:
//		I'm worried about having a couple of items in here (at least in their current form)
//		In particular:
//			MarkChanged()
//			LocalToGlobal()
//			GlobalToLocal()
class TDrawSlate
{
private:
	int mhCount;
	TDrawSlate *mhOldFocus;
	static TDrawSlate *shCurFocus;
	Point mhOrigin;
protected:
	virtual Boolean GetDrawSelf();
	virtual Boolean ReleaseDrawSelf();
public:
	TDrawSlate();
	virtual ~TDrawSlate();
	void SetOrigin( int x, int y ) {mhOrigin.h= x; mhOrigin.v= y;};
	void GetOrigin( int &x, int &y ) {x= mhOrigin.h; y= mhOrigin.v;};
	virtual void MarkChanged( Rect );
	virtual Boolean GetDrawFocus();
	virtual Boolean ReleaseDrawFocus();
	virtual void LocalToGlobal( Point* );
	virtual void GlobalToLocal( Point* );
};

#endif